<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package Plugins
 */
/**************************************************************************/

class Discount_Admin extends A_MainFrame
{
  function __construct()
  {
    parent::__construct("plugin_discount.tpl");

	$this->AddJScript("/plugins/discount/admin/discount.js");
  }

  function Action($action)
  {
    $res=false;
    switch($action)
    { case "add": $res=$this->Add(); break;
	  case "edit": $res=$this->Edit(); break;
	  case "del": $res=$this->Del(); break;
	}
    if($res)
	A::goUrl("admin.php?mode=structures&item=".ITEM);
  }

  function Add()
  {
	if($_REQUEST['type']=='fix')
	{ $section=getSectionByModule('shoplite');
	  $_idcats=A::$DB->getCol("SELECT id FROM {$section}_categories");
	  $_categories=array();
	  foreach($_idcats as $idcat)
      if($category=getTreePath("{$section}_categories",$idcat,' - '))
	  $_categories[$category]=$idcat;
	  $rules=array('categories'=>array(),'allcategories'=>array(),'groups'=>!empty($_REQUEST['groups'])?$_REQUEST['groups']:array());
	  $categories=explode(',',$_REQUEST['categories']);
	  foreach($categories as $category)
	  if($category=trim($category))
	  { if(isset($_categories[$category]))
	    { $rules['categories'][]=$_categories[$category];
		  $allcats=array($_categories[$category]);
	      getTreeSubItems("{$section}_categories",$_categories[$category],$allcats);
		  $rules['allcategories']=array_merge($rules['categories'],$allcats);
	    }
	  }
	  $rules['categories']=array_unique($rules['categories']);
	  $rules['allcategories']=array_unique($rules['allcategories']);
	  $_REQUEST['rules']=serialize($rules);
	}
	elseif($_REQUEST['type']=='var')
	{ $rules['vars']=array();
	  $vars=explode(',',$_REQUEST['vars']);
	  foreach($vars as $v)
	  { $v=explode('=',$v);
	    if(count($v)==2)
	    $rules['vars'][trim($v[0])]=trim($v[1]);
	  }
      $_REQUEST['rules']=serialize($rules);
	}
	else
	$_REQUEST['rules']='';
	$_REQUEST['sum']=round($_REQUEST['sum'],2);
	$_REQUEST['date']=isset($_REQUEST['date'])?'Y':'N';
	$_REQUEST['active']=isset($_REQUEST['active'])?'Y':'N';

    setOption(STRUCTURE,'dec',(integer)$_REQUEST['dec']);

	$dataset = new A_DataSet(STRUCTURE);
	$dataset->fields=array("type","sum","discount","date","date1","date2","rules","active");
	return $dataset->Insert();
  }

  function Edit()
  {
	if($_REQUEST['type']=='fix')
	{ $section=getSectionByModule('shoplite');
	  $_idcats=A::$DB->getCol("SELECT id FROM {$section}_categories");
	  $_categories=array();
	  foreach($_idcats as $idcat)
      if($category=getTreePath("{$section}_categories",$idcat,' - '))
	  $_categories[$category]=$idcat;
	  $rules=array('categories'=>array(),'allcategories'=>array(),'groups'=>!empty($_REQUEST['groups'])?$_REQUEST['groups']:array());
	  $categories=explode(',',$_REQUEST['categories']);
	  foreach($categories as $category)
	  if($category=trim($category))
	  { if(isset($_categories[$category]))
	    { $rules['categories'][]=$_categories[$category];
		  $allcats=array($_categories[$category]);
	      getTreeSubItems("{$section}_categories",$_categories[$category],$allcats);
		  $rules['allcategories']=array_merge($rules['categories'],$allcats);
	    }
	  }
	  $rules['categories']=array_unique($rules['categories']);
	  $rules['allcategories']=array_unique($rules['allcategories']);
	  $_REQUEST['rules']=serialize($rules);
	}
	elseif($_REQUEST['type']=='var')
	{ $rules=array();
	  $vars=explode(',',$_REQUEST['vars']);
	  foreach($vars as $v)
	  { $v=explode('=',$v);
	    if(count($v)==2)
	    $rules['vars'][trim($v[0])]=trim($v[1]);
	  }
      $_REQUEST['rules']=serialize($rules);
	}
	else
	$_REQUEST['rules']='';
	$_REQUEST['sum']=round($_REQUEST['sum'],2);
	$_REQUEST['dec']=(integer)$_REQUEST['dec'];
	$_REQUEST['date']=isset($_REQUEST['date'])?'Y':'N';
	$_REQUEST['active']=isset($_REQUEST['active'])?'Y':'N';

	setOption(STRUCTURE,'dec',(integer)$_REQUEST['dec']);

	$dataset = new A_DataSet(STRUCTURE);
	$dataset->fields=array("type","sum","discount","date","date1","date2","rules","active");
	return $dataset->Update();
  }

  function Del()
  {
  	$dataset = new A_DataSet(STRUCTURE);
    return $dataset->Delete();
  }

  function createData()
  {
	$this->Assign("shopassoc",$section=getSectionByModule('shoplite'));

	if(empty($section)) return;

	$this->Assign("valute",getOption($section,'valute'));

	$discounts=array();
	A::$DB->query("SELECT * FROM ".STRUCTURE." ORDER BY type,sum");
	while($row=A::$DB->fetchRow())
	{ if($row['type']=='fix')
	  { $rules=!empty($row['rules'])?unserialize($row['rules']):array();
		$categories=array();
		if($rules['categories'])
		foreach($rules['categories'] as $idcat)
		$categories[]=getTreePath("{$section}_categories",$idcat,' - ');
		$row['categories']=implode(', ',$categories);
	    $row['note']="Категории: ".($row['categories']?$row['categories']:"Все");
	    if($structure=getStructureByPlugin("groups"))
	    { $groups=$rules['groups']?A::$DB->getCol("SELECT name FROM {$structure} WHERE id IN(".implode(',',$rules['groups']).")"):array();
	      $row['groups']=implode(', ',$groups);
	      $row['note'].=", Группы: ".($row['groups']?$row['groups']:"Все");
	    }
	  }
	  if($row['type']=='var')
	  { $rules=!empty($row['rules'])?unserialize($row['rules']):array();
	    $vars=array();
	    foreach($rules['vars'] as $f=>$v)
	    $vars[]="{$f}={$v}";
	    $row['note']=implode(',',$vars);
	  }
	  $discounts[]=$row;
	}
	A::$DB->free();

	$this->Assign("discounts",$discounts);
  }
}

A::$MAINFRAME = new Discount_Admin;