<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2011 " "
 * @author Vitaly Hohlov <admin@a-cms.ru>
 * @package Plugins
 */
/**************************************************************************/

class Discount_Request extends A_Request
{
  function Action($action)
  {
    switch($action)
    { case "getaddform": $this->getAddForm(); break;
	  case "geteditform": $this->getEditForm(); break;
	  case "getcategories": $this->getCategories(); break;
    }
  }

  function getAddForm()
  {
    $form = new A_Form("plugin_discount_add.tpl");
    $form->data['users']=getSectionByModule('users');
    if($structure=getStructureByPlugin("groups"))
	$form->data['groups']=A::$DB->getAssoc("SELECT id,name FROM {$structure} ORDER BY sort");
	$form->data['dec']=getOption(STRUCTURE,'dec');
	$this->RESULT['html'] = $form->getContent();
  }

  function getEditForm()
  {
    $form = new A_Form("plugin_discount_edit.tpl");
	$form->data=A::$DB->getRowById($_POST['id'],STRUCTURE);
	$rules=!empty($form->data['rules'])?unserialize($form->data['rules']):array();
	if(!empty($rules['categories']))
	{ $section=getSectionByModule('shoplite');
	  $categories=array();
	  foreach($rules['categories'] as $idcat)
	  $categories[]=getTreePath("{$section}_categories",$idcat,' - ');
	  $form->data['categories']=implode(', ',$categories);
	}
	if(!empty($rules['vars']))
	{ $form->data['vars']=array();
	  foreach($rules['vars'] as $f=>$v)
	  $form->data['vars'][]="{$f}={$v}";
	  $form->data['vars']=implode(',',$form->data['vars']);
	}
	$form->data['users']=getSectionByModule('users');
	if($structure=getStructureByPlugin("groups"))
	$form->data['groups']=A::$DB->getAssoc("SELECT id,name FROM {$structure} ORDER BY sort");
	$form->data['gr']=!empty($rules['groups'])?$rules['groups']:array();
	$form->data['sum']=$form->data['sum']>0?$form->data['sum']:"";
	$form->data['dec']=getOption(STRUCTURE,'dec');

	$this->RESULT['html'] = $form->getContent();
  }

  function getCategories()
  {
    $query = A::$DB->real_escape_string(mb_strtolower($_POST['query']));
    if($section=getSectionByModule('shoplite'))
    { if($idcats=A::$DB->getCol("SELECT id FROM {$section}_categories WHERE name LIKE '{$query}%' LIMIT 0,20"))
      { $items=array();
	    foreach($idcats as $idcat)
        $items[]='<li>'.getTreePath("{$section}_categories",$idcat,' - ').'</li>';
        print '<ul>'.implode("",$items).'</ul>';
      }
      else
      print '<span></span>';
    }
    else
    print '<span></span>';
  }
}

A::$REQUEST = new Discount_Request;